ARX实现ZOOM功能

原文链接

// This is command 'ZOOMEXT, by Fenton Webb [Apr/17/2002], DevTech, Autodesk
void asdkzoomExt()
{
// get the extents of the drawing
AcDbViewTableRecord view;
AcGePoint3d max =
acdbHostApplicationServices()->workingDatabase()->extmax(),
       min = acdbHostApplicationServices()->workingDatabase()->extmin();
AcGePoint2d max_2d (max[X], max[Y]);
AcGePoint2d min_2d (min[X], min[Y]);
// now set the view centre point
view.setCenterPoint (min_2d + (max_2d - min_2d) / 2.0);
// now height and width of view
view.setHeight(max_2d[Y] - min_2d[Y]);
view.setWidth (max_2d[X] - min_2d[X]);
// set the view
acedSetCurrentView (&view, NULL);
// updates the extents
acdbHostApplicationServices()->workingDatabase()->updateExt(TRUE);
}
////////////////////////////////////////////////////////////////////////////
//
// This is command 'ZOOMWIN, by Fenton Webb [Apr/17/2002], DevTech, Autodesk
void asdkzoomWin()
{
AcGePoint3d max, min;
// get the window coords
int res = acedGetPoint (NULL, "/nPick zoom window pnt : ",
asDblArray(min));
// if ok
if (res == RTNORM)
{
  res = acedGetCorner (asDblArray(min), "/nPick other corner : ",
asDblArray(max));
  // get the extents of the drawing
  AcDbViewTableRecord view;
  AcGePoint2d max_2d (max[X], max[Y]);
  AcGePoint2d min_2d (min[X], min[Y]);
  // now set the view centre point
  view.setCenterPoint (min_2d + (max_2d - min_2d) / 2.0);
  // now height and width of view
  view.setHeight(max_2d[Y] - min_2d[Y]);
  view.setWidth (max_2d[X] - min_2d[X]);
  // set the view
  acedSetCurrentView (&view, NULL);
  // updates the extents
  acdbHostApplicationServices()->workingDatabase()->updateExt(TRUE);
}
}
  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值